problemsets/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  get 'ps6/index'
  get 'ps5/index'
  get 'team_leader/index'
  get 'team_leader/show'
  get 'team_leader/assign_team', to: 'team_leader#assign'
  put 'team_leader/assign_team', to: 'team_leader#update'
  get 'reception/index'
  get 'reception/show'
  get 'medical_officer/index'
  get 'medical_officer/show'
  get 'doctor/index'
  get 'doctor/show'
  get 'admin/index'
  get 'admin/add_user', to: 'admin#new'
  post 'admin/add_user', to: 'admin#add_user'
  get 'admin/edit_user', to: 'admin#edit'
  post 'admin/reset_pwd', to: 'admin#reset'
  put 'admin/edit_user', to: 'admin#update'
  post 'admin/delete', to: 'admin#destroy'
  post 'admin/ban_user', to: 'admin#ban'
  post 'admin/allow_user', to: 'admin#allow'
  get 'admin/show'
  get 'session/index'
  get 'ps4/index'
  devise_for :users
  get 'ps3/index'
  get 'ps3/reception'
  get 'ps3/medical_officer'
  get 'ps3/doctor'
  get 'ps3/team_leader'
  get 'basic2/quotations'
  post 'basic2/quotations'
  resources :basics do
    member do
      get :divide_by_zero
    end
  end
  # get 'basics/divide_by_zero'
  get 'home/index'
  get 'home/about'
  root to: 'home#index'

  # devise_for :users
  devise_scope :user do
    get '/users/sign_out' => 'devise/sessions#destroy'
  end
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

problemsets/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

problemsets/app/models/basic.rb
class Basic < ApplicationRecord
end

problemsets/app/models/category.rb
class Category < ApplicationRecord
  has_many :quotations
  
end

problemsets/app/models/gender.rb
class Gender < ApplicationRecord
  has_many :users
end

problemsets/app/models/phone.rb
class Phone < ApplicationRecord
  belongs_to :user
end

problemsets/app/models/quotation.rb
class Quotation < ApplicationRecord
  belongs_to :category

  validates_presence_of :author_name, :quote, :category_id
end

problemsets/app/models/role.rb
class Role < ApplicationRecord
  has_many :users
end

problemsets/app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  belongs_to :role
  has_many :phones
  belongs_to :gender
end

problemsets/app/controllers/ps3_controller.rb
class Ps3Controller < ApplicationController
  def index
  end
end

problemsets/app/controllers/ps4_controller.rb
class Ps4Controller < ApplicationController
  def index
  end
end

problemsets/app/controllers/reception_controller.rb
class ReceptionController < ApplicationController
  before_action :authenticate_user!
  before_action :set_user, only: %i[show]

  def index
    doc_role_id = Role.find_by_name('Doctor').id
    if params[:search_doctor]
      user_query = "role_id = #{doc_role_id} AND lower(email) LIKE?"
      @doctors = User.where(user_query, "%#{params[:search]}%")
    else
      user_query = "role_id = #{doc_role_id}"
      @doctors = User.where(user_query)
    end

    med_role_id = Role.find_by_name('Medical Officer').id
    if params[:search_medical_officer]
      user_query = "role_id = #{med_role_id} AND lower(email) LIKE?"
      @medicalofficers = User.where(user_query, "%#{params[:search]}%")
    else
      user_query = "role_id = #{med_role_id}"
      @medicalofficers = User.where(user_query)
    end
  end

  def show; end

  private

  def set_user
    @user = User.find(params[:id])
  end
end

problemsets/app/helpers/admin_helper.rb
module AdminHelper
end

problemsets/app/helpers/basic2_helper.rb
module Basic2Helper
end

problemsets/app/helpers/basics_helper.rb
module BasicsHelper
end

problemsets/app/helpers/doctor_helper.rb
module DoctorHelper
end

problemsets/app/helpers/home_helper.rb
module HomeHelper
end

problemsets/app/helpers/ps3_helper.rb
module Ps3Helper
end

problemsets/app/helpers/ps4_helper.rb
module Ps4Helper
end

problemsets/app/helpers/ps5_helper.rb
module Ps5Helper
end

problemsets/app/helpers/ps6_helper.rb
module Ps6Helper
end

problemsets/app/helpers/reception_helper.rb
module ReceptionHelper
end

problemsets/app/helpers/session_helper.rb
module SessionHelper
end

problemsets/app/views/reception/index.html.erb
<h1>Reception#index</h1>
<%= link_to 'Profile', reception_show_path(id: current_user.id) %>

<h2>Doctors</h2>

<div>
  <%= form_tag 'index', method: :get do %>
    <div class="input-group">
      <%= text_field_tag :search_doctor, {}, class: 'form-control mx-2', placeholder: 'Name or Email' %>
      <%= submit_tag 'Search', class: 'btn btn-danger mx-2' %>
      <%= submit_tag 'Show All', class: 'btn btn-danger mx-2' %>
    </div>
  <% end %>
</div>

<br/>

<table class="table table-striped table-bordered" id="users_table">
  <thead>
  <tr>
    <th class="col-3">Name</th>
    <th class="col-3">Team</th>
    <th class="col-3">Email</th>
    <th class="col-3">Option</th>
  </tr>
  </thead>
  <tbody>
  <% @doctors.each do |user| %>
    <tr>
      <td class="col-3"><%= user.name %></td>
      <td class="col-3"><%= user.team %></td>
      <td class="col-3"><%= user.email %></td>
      <td class="col-3">
        Something
      </td>
    </tr>
  <% end %>
  </tbody>
</table>
</div>

<br/>

<h2>Medical Officer</h2>

<div>
  <%= form_tag 'index', method: :get do %>
    <div class="input-group">
      <%= text_field_tag :search_medical_officer, {}, class: 'form-control mx-2', placeholder: 'Name or Email' %>
      <%= submit_tag 'Search', class: 'btn btn-danger mx-2' %>
      <%= submit_tag 'Show All', class: 'btn btn-danger mx-2' %>
    </div>
  <% end %>
</div>

<br/>

<table class="table table-striped table-bordered" id="users_table">
  <thead>
  <tr>
    <th class="col-3">Name</th>
    <th class="col-3">Team</th>
    <th class="col-3">Email</th>
    <th class="col-3">Option</th>
  </tr>
  </thead>
  <tbody>
  <% @medicalofficers.each do |user| %>
    <tr>
      <td class="col-3"><%= user.name %></td>
      <td class="col-3"><%= user.team %></td>
      <td class="col-3"><%= user.email %></td>
      <td class="col-3">
        Something
      </td>
    </tr>
  <% end %>
  </tbody>
</table>
</div>

<br/>

problemsets/app/views/reception/show.html.erb
<div class="container">
  <%= link_to 'Back', reception_index_path,class: 'btn btn-danger'%>
  <br/>
  <div class="main-body">

    <div class="row gutter-sm">

      <div class="col-md-4 mb-3">
        <div class="card">
          <div class="card-body">
            <div class="d-flex flex-column align-items-center text-center">
              <%= image_tag 'user_profile.png', alt: 'reception profile pic', class: 'rounded-circle', width: '150'%>
              <div class="mt-3">
                <h4><%= @user.name %></h4>
                <p class=" mb-1"><%= @user.role.name %></p>
                <p class="text-muted font-size-sm">Team <%= @user.team %></p>
                <button class="btn btn-outline-danger">Contact</button>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-md-8">
        <div class="card mb-3">
          <div class="card-body">
            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Full Name</h6>
              </div>
              <div class="col-sm-9">
                <%= @user.name %>
              </div>
            </div>

            <hr/>

            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Position</h6>
              </div>
              <div class="col-sm-9">
                <%= @user.role.name %>
              </div>
            </div>

            <br/>

            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Team Number</h6>
              </div>
              <div class="col-sm-9">
                <%= @user.team %>
              </div>
            </div>

            <br/>

            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Education</h6>
              </div>
              <div class="col-sm-9">
                <%= @user.education %>
              </div>
            </div>

            <br/>

            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Marital Status</h6>
              </div>
              <div class="col-sm-9">
                <% if @user.marital_status %>
                  Married
                <% else %>
                  Single
                <% end %>
              </div>
            </div>

            <br/>

            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Gender</h6>
              </div>
              <div class="col-sm-9">
                <%= @user.gender.gender %>
              </div>
            </div>

            <br/>

            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Email</h6>
              </div>
              <div class="col-sm-9">
                <%= @user.email %>
              </div>
            </div>

            <br/>

            <% Phone.where(user_id: @user.id, mobile: false).each do |phone| %>
              <div class="row">
                <div class="col-sm-3">
                  <h6 class="mb-0">Phone</h6>
                </div>
                <div class="col-sm-9">
                  <%= phone.number %>
                </div>
              </div>
              <br/>
            <% end %>

            <% Phone.where(user_id: @user.id, mobile: true).each do |phone| %>
              <div class="row">
                <div class="col-sm-3">
                  <h6 class="mb-0">Mobile</h6>
                </div>
                <div class="col-sm-9">
                  <%= phone.number %>
                </div>
              </div>
              <br/>
          <% end %>

            <div class="row">
              <div class="col-sm-3">
                <h6 class="mb-0">Address</h6>
              </div>
              <div class="col-sm-9">
                <%= @user.address %>
              </div>
            </div>

            <br/>

            <div class="row">
              <div class="col-sm-12">
                <%= link_to 'Edit', admin_index_path, class: 'btn btn-danger' %>
              </div>
            </div>

          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<br/>
<br/>